
#property indicator_chart_window 
#property indicator_buffers 8 
#property indicator_color1 Blue//wick 
#property indicator_color2 Violet//wick 
#property indicator_color3 Blue//candle
#property indicator_color4 Violet//candle 
#property indicator_color5 Red//wick 
#property indicator_color6 DodgerBlue//wick 
#property indicator_color7 Red//candle
#property indicator_color8 DodgerBlue//candle 
#property indicator_width1 1 
#property indicator_width2 1
#property indicator_width3 3 
#property indicator_width4 3 
#property indicator_width5 1 
#property indicator_width6 1
#property indicator_width7 3 
#property indicator_width8 3 
//---- stoch settings 
extern bool Candles = true;
extern bool Hide    = false;
extern int EMA_Period = 21; 
extern int EMA_Price = 0; 
extern int EMA_Mode = 1;
//---- input parameters 
extern int BarWidth = 1, CandleWidth = 3; 

//---- buffers 
double Bar1[], Bar2[], Candle1[], Candle2[],buf2[], buf3[],Bar3[], Bar4[], Candle3[], Candle4[],ExtMapBuffer1[],ExtMapBuffer2[]; 
//+------------------------------------------------------------------+ 
//| Custom indicator initialization function | 
//+------------------------------------------------------------------+ 
   int  init()
     
     {
     
     ArrayInitialize(Bar1,EMPTY_VALUE);
     ArrayInitialize(Bar2,EMPTY_VALUE);
     ArrayInitialize(Bar3,EMPTY_VALUE);
     ArrayInitialize(Bar4,EMPTY_VALUE);
     ArrayInitialize(Candle1,EMPTY_VALUE);
     ArrayInitialize(Candle2,EMPTY_VALUE);
     ArrayInitialize(Candle3,EMPTY_VALUE);
     ArrayInitialize(Candle4,EMPTY_VALUE);
     
  /*   
     	 if(WindowBarsPerChart() >= 250)
     {
      CandleWidth = 2;
     }
     else if (WindowBarsPerChart() >= 175)
     {
      CandleWidth = 3;
     }
     else if (WindowBarsPerChart() >= 100)
     {
      CandleWidth = 6;
     }
      else if (WindowBarsPerChart() < 100)
     {
      CandleWidth = 13;
     }
			
 */    
     
     
     	if(Candles == True)
				{
					SetIndexBuffer(0,Bar1); 
               SetIndexBuffer(1,Bar2); 
               SetIndexBuffer(2,Candle1); 
               SetIndexBuffer(3,Candle2); 
               SetIndexBuffer(4,Bar3); 
               SetIndexBuffer(5,Bar4); 
               SetIndexBuffer(6,Candle3); 
               SetIndexBuffer(7,Candle4); 
               SetIndexStyle(0,DRAW_HISTOGRAM,0,BarWidth); 
               SetIndexStyle(1,DRAW_HISTOGRAM,0,BarWidth); 
               SetIndexStyle(2,DRAW_HISTOGRAM,0,CandleWidth); 
               SetIndexStyle(3,DRAW_HISTOGRAM,0,CandleWidth); 
               SetIndexStyle(4,DRAW_HISTOGRAM,0,BarWidth); 
               SetIndexStyle(5,DRAW_HISTOGRAM,0,BarWidth); 
               SetIndexStyle(6,DRAW_HISTOGRAM,0,CandleWidth); 
               SetIndexStyle(7,DRAW_HISTOGRAM,0,CandleWidth); 
				}
			else
				{
					SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 1);
					SetIndexBuffer(1, buf2);   
					SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 1);   
					SetIndexBuffer(0, buf3);
				}
				
				
		return(0);
		
	}	
	
	
	//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  
//----
   return(0);
  }

//
 //+------------------------------------------------------------------+ 
 double EMA (int i = 0) 
 {
 return(iMA(NULL,0,EMA_Period,0,EMA_Mode,EMA_Price,i));
 } 
 //+------------------------------------------------------------------+ 
 
 

 //+------------------------------------------------------------------+ 
 
  void SetCandleColor(int col, int i) 
 { 
 double high,low,bodyHigh,bodyLow; 
 {
  bodyHigh = MathMax(Open[i],Close[i]); 
  bodyLow = MathMin(Open[i],Close[i]); 
  high = High[i]; 
  low = Low[i]; 
  } 
  Bar1[i] = low;
   Candle1[i] = bodyLow;
    Bar2[i] = low;
     Candle2[i] = bodyLow;
     Bar3[i] = low;
   Candle3[i] = bodyLow;
    Bar4[i] = low;
     Candle4[i] = bodyLow;
      switch(col)
       { 
       case 1: 
       Bar1[i] = high; 
       Candle1[i] = bodyHigh; 
       break; 
       
       case 2: 
       Bar2[i] = high;
        Candle2[i] = bodyHigh;
         break; 
         
         case 3: 
       Bar3[i] = high; 
       Candle3[i] = bodyHigh; 
       break; 
       case 4: 
       
       Bar4[i] = high;
        Candle4[i] = bodyHigh;
         break; 
         }
          }
		  
           //+------------------------------------------------------------------+ //| Custom indicator iteration function |
            //+------------------------------------------------------------------+ 
           int start() 
           { 
		   
		   if(Hide) return(0);
		   else
		   {
		   
		   //---- indicators 
			IndicatorShortName("EMA Candles:("+ EMA_Period+")"); 
			
			
			
		
			
			
			
		
/*
			if(Candles == True)
				{
					SetIndexBuffer(0,Bar1); 
               SetIndexBuffer(1,Bar2); 
               SetIndexBuffer(2,Candle1); 
               SetIndexBuffer(3,Candle2); 
               SetIndexBuffer(4,Bar3); 
               SetIndexBuffer(5,Bar4); 
               SetIndexBuffer(6,Candle3); 
               SetIndexBuffer(7,Candle4); 
               SetIndexStyle(0,DRAW_HISTOGRAM,0,BarWidth); 
               SetIndexStyle(1,DRAW_HISTOGRAM,0,BarWidth); 
               SetIndexStyle(2,DRAW_HISTOGRAM,0,CandleWidth); 
               SetIndexStyle(3,DRAW_HISTOGRAM,0,CandleWidth); 
               SetIndexStyle(4,DRAW_HISTOGRAM,0,BarWidth); 
               SetIndexStyle(5,DRAW_HISTOGRAM,0,BarWidth); 
               SetIndexStyle(6,DRAW_HISTOGRAM,0,CandleWidth); 
               SetIndexStyle(7,DRAW_HISTOGRAM,0,CandleWidth); 
				}
			else
				{
					SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 1);
					SetIndexBuffer(1, buf2);   
					SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 1);   
					SetIndexBuffer(0, buf3);
				}

		   */
		   
		   
           for(int i = MathMax(Bars-1-IndicatorCounted(),1);
            i>=0; i--) 
            { 
            double ema = EMA(i);
           
             
//+------------------------------------------------------------------+
//|COLOURS                                                           | 
//| BLUE - ALL 3 conditions BULL                                     | 
//| Dodger Blue - Bull Candle and Price < EMA                           |
//| Normal Up - Bull Candle and price > EMA                |
//| RED - ALL 3 conditions BEAR                                      |
//| Violet - Bear Candle and RSI > 50                                |
//| Normal Down - Bear Candle and RSI < 50 but BB wrong              |
//|                                                                  |
//+------------------------------------------------------------------+      
             
             
			if(Candles)
				{
					if(Close[i] > ema && Close[i]>Open[i] ) 
					{
					    SetCandleColor(1,i); // BLUE
					}    
					
					else if(Close[i] > ema && Close[i]<Open[i] ) 
					
					{
					    SetCandleColor(2,i); // Tomato
					}   
									
					
					else if(Close[i] < ema && Close[i] < Open[i]) 
					{
					
					    SetCandleColor(3,i); // RED
					}
					
					else if(Close[i] < ema && Close[i] > Open[i]) 
					{
					
					    SetCandleColor(4,i); // Dodger Blue
					}
					
					   
				}
				
			else
			{
				if (Close[i] == ema) 
					{
						buf2[i] = Low[i];
						buf3[i] = High[i];
					}	
				else{
						buf2[i] = High[i];
						buf3[i] = Low[i];
					}
			
			}
			
            } }//else bracket
               return(0);
                } 
                //+------------------------------------------------------------------+ 